function mdp = make_disc_mdp()
%
% Generate Simple Markov Decision Process (MDP) 
% 

% 1. State space
mdp.nr_s = 6;
mdp.s = cell(6, 1);
for i = 1:6
    mdp.s{i}.name = sprintf('%d', i);
end
mdp.s{1}.pos = [-1 -1];
mdp.s{2}.pos = [0 1];
mdp.s{3}.pos = [-1 0];
mdp.s{4}.pos = [0 0];
mdp.s{5}.pos = [0 -1];
mdp.s{6}.pos = [1 0];
% Initial probability
mdp.b = ones(mdp.nr_s, 1)/mdp.nr_s;
% Terminate state
mdp.ts = [6];

% 2. Trasition matrix (S \times A \times S)
% below is not actual T! 
mdp.T = [ ...
      0 0 0 0 1 0 ...
    ; 0 0 0 1 0 1 ...
    ; 0 0 0 1 0 0 ...
    ; 0 1 1 0 1 0 ...
    ; 1 0 0 1 0 1 ...
    ; 0 1 0 0 1 1];

% 3. Action space
mdp.nr_a = 6;

% 4. Reward (S \times A)
mdp.R = [-1 -1 -1 -1 0 -1 ....
    ; -1 -1 -1 0 -1 100 ...
    ; -1 -1 -1 0 -1 -1 ...
    ; -1 0 0 -1 0 -1 ...
    ; 0 -1 -1 0 -1 100 ...
    ; -1 0 -1 -1 0 100 ];

% 4. Q matrix (S \times A)
mdp.Q = zeros(mdp.nr_s, mdp.nr_a);

% 5. Discount factor
mdp.gamma = 0.8;